# Interface: Remote

The public interface for WireClient, GoogleDrive & Dropbox

## Properties

### connected

> **connected**: `boolean`

Whether or not a remote store is connected

#### Defined in

[remote.ts:82](https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/remote.ts#L82)

***

### online

> **online**: `boolean`

Whether last sync action was successful or not

#### Defined in

[remote.ts:87](https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/remote.ts#L87)

***

### properties?

> `optional` **properties**: `object`

The JSON-parsed properties object from the user's WebFinger record

#### Defined in

[remote.ts:123](https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/remote.ts#L123)

***

### userAddress

> **userAddress**: `string`

The user address of the connected user

#### Defined in

[remote.ts:92](https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/remote.ts#L92)
