# Publishing and finding data modules

## npm

The recommended way for publishing data modules is as
[npm](https://www.npmjs.com/) packages.

Our naming convention for rs.js modules is
`remotestorage-module-mymodulename`. Thus, you can also find them by
[searching npm for
"remotestorage-module"](https://www.npmjs.com/search?q=remotestorage-module).

You can also add "remotestorage-module" and "remotestorage" to the
`keywords` property of your `package.json`.

## GitHub & Co.

If you use GitHub ‒ or any other code hosting/collaboration platform for
that matter ‒ for publishing your module's source code, please use the
same naming convention as for the npm module for the repo name. And
it's a good idea to add the topic/tag/label "remotestorage-module"
there as well, of course.

<https://github.com/topics/remotestorage-module>

::: tip
With npm, you can also install modules directly from a Git repository or
GitHub, pointing to just the repo or a branch name, tag, or commit:
https://docs.npmjs.com/cli/v10/configuring-npm/package-json#github-urls
:::
