import{_ as e,c as t,o as r,a2 as a}from"./chunks/framework.BaHG-QLs.js";const u=JSON.parse('{"title":"remoteStorage.js","description":"","frontmatter":{},"headers":[],"relativePath":"api/index.md","filePath":"api/index.md"}'),o={name:"api/index.md"},s=a(`<h1 id="remotestorage-js" tabindex="-1">remoteStorage.js <a class="header-anchor" href="#remotestorage-js" aria-label="Permalink to &quot;remoteStorage.js&quot;">​</a></h1><p><a href="https://www.npmjs.com/package/remotestoragejs" target="_blank" rel="noreferrer"><img src="https://img.shields.io/npm/v/remotestoragejs.svg" alt="npm"></a><a href="https://github.com/remotestorage/remotestorage.js/actions/workflows/test-and-lint.yml?query=branch%3Amaster" target="_blank" rel="noreferrer"><img src="https://github.com/remotestorage/remotestorage.js/actions/workflows/test-and-lint.yml/badge.svg" alt="Build Status"></a></p><p>remoteStorage.js is a JavaScript library for storing user data locally in the browser, as well as connecting to <a href="http://remotestorage.io" target="_blank" rel="noreferrer">remoteStorage</a> servers and syncing data across devices and applications. It is also capable of connecting and syncing data with a person&#39;s Dropbox or Google Drive account (optional).</p><p>The library is well-tested and actively maintained. It is safe to use in production.</p><h3 id="where-to-get-help" tabindex="-1">Where to get help? <a class="header-anchor" href="#where-to-get-help" aria-label="Permalink to &quot;Where to get help?&quot;">​</a></h3><ul><li>See <a href="http://remotestorage.io/" target="_blank" rel="noreferrer">remotestorage.io</a> for general information about the remoteStorage protocol</li><li>Read <a href="http://remotestoragejs.readthedocs.io/" target="_blank" rel="noreferrer">the docs</a> (source files in <code>doc/</code>) <ul><li><a href="https://remotestoragejs.readthedocs.io/en/latest/why.html" target="_blank" rel="noreferrer">Why use this?</a></li><li><a href="https://remotestoragejs.readthedocs.io/en/latest/getting-started.html" target="_blank" rel="noreferrer">Getting started</a></li><li><a href="https://remotestoragejs.readthedocs.io/en/latest/data-modules.html" target="_blank" rel="noreferrer">Data modules</a></li><li><a href="https://remotestoragejs.readthedocs.io/en/latest/js-api.html" target="_blank" rel="noreferrer">JavaScript API</a></li><li><a href="https://remotestoragejs.readthedocs.io/en/latest/nodejs.html" target="_blank" rel="noreferrer">Usage with Node.js</a></li></ul></li><li>Ask questions on the <a href="https://community.remotestorage.io/" target="_blank" rel="noreferrer">community forums</a></li><li>Ask questions on IRC in <a href="ircs://irc.libera.chat:6697/remotestorage" target="_blank" rel="noreferrer">#remotestorage on Libera.Chat</a> (<a href="https://web.libera.chat/#remotestorage" target="_blank" rel="noreferrer">Web Chat</a>) (wait a bit, if nobody&#39;s responding right away)</li><li>If you found a potential bug, or want to propose a change, <a href="https://github.com/remotestorage/remotestorage.js/issues" target="_blank" rel="noreferrer">open an issue on GitHub</a>. New issues will usually receive a response within 24-48 hours.</li></ul><h3 id="running-a-local-test-server" tabindex="-1">Running a local test server <a class="header-anchor" href="#running-a-local-test-server" aria-label="Permalink to &quot;Running a local test server&quot;">​</a></h3><p>To develop remoteStorage-enabled apps, you need to have a remoteStorage-compatible storage account. We recommend <a href="https://github.com/fkooman/php-remote-storage" target="_blank" rel="noreferrer">php-remote-storage</a> (PHP), or <a href="https://github.com/remotestorage/armadietto" target="_blank" rel="noreferrer">armadietto</a> (node.js), or <a href="https://github.com/untitaker/mysteryshack" target="_blank" rel="noreferrer">mysteryshack</a> (Rust) for running a local test server, or for self-hosting an RS server.</p><p>You can also get an account with a hoster, or use another remoteStorage server implementation: <a href="https://wiki.remotestorage.io/Servers" target="_blank" rel="noreferrer">Servers</a>.</p><h3 id="visual-file-browser" tabindex="-1">Visual File Browser <a class="header-anchor" href="#visual-file-browser" aria-label="Permalink to &quot;Visual File Browser&quot;">​</a></h3><p>If you&#39;d like a visual UI for inspecting any RS-compatible account, you can use the <a href="https://gitea.kosmos.org/raucao/inspektor" target="_blank" rel="noreferrer">RS Inspektor</a> app (which is also implemented using this library).</p><h3 id="developing-contributing" tabindex="-1">Developing, Contributing <a class="header-anchor" href="#developing-contributing" aria-label="Permalink to &quot;Developing, Contributing&quot;">​</a></h3><p>remoteStorage.js is a grassroots project, developed by the community, for the community. We&#39;d be happy to count you among the many <a href="https://github.com/remotestorage/remotestorage.js/graphs/contributors" target="_blank" rel="noreferrer">people who contributed</a> to the project so far!</p><p>Read our <a href="https://remotestoragejs.readthedocs.io/en/latest/contributing.html" target="_blank" rel="noreferrer">Contributing docs</a> to get started.</p><h3 id="versioning" tabindex="-1">Versioning <a class="header-anchor" href="#versioning" aria-label="Permalink to &quot;Versioning&quot;">​</a></h3><p>We adhere to <a href="http://semver.org/" target="_blank" rel="noreferrer">Semantic Versioning</a>. This means that breaking changes will result in a new major version. With npm, you can make sure to only automatically upgrade to API-compatible versions by using either the <code>^</code> prefix, or <code>x</code> as indicator for flexible numbers:</p><div class="language-js vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">js</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;devDependencies&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: {</span></span>
<span class="line"><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">  &quot;remotestoragejs&quot;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">: </span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&quot;1.x&quot;</span><span style="--shiki-light:#6A737D;--shiki-dark:#6A737D;"> // same as &quot;^1.0.0&quot;</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">}</span></span></code></pre></div><h3 id="credits" tabindex="-1">Credits <a class="header-anchor" href="#credits" aria-label="Permalink to &quot;Credits&quot;">​</a></h3><p>Original authors: Niklas Cathor, Michiel de Jong</p><p>See <a href="https://github.com/remotestorage/remotestorage.js/graphs/contributors" target="_blank" rel="noreferrer">list of all contributors</a></p><p>Previously sponsored by <a href="https://nlnet.nl" target="_blank" rel="noreferrer">NLnet</a></p><p><a href="https://nlnet.nl" target="_blank" rel="noreferrer"><img src="http://sockethub.org/res/img/nlnet-logo.svg" alt="NLnet Logo"></a></p>`,22),i=[s];function n(l,h,g,p,c,d){return r(),t("div",null,i)}const b=e(o,[["render",n]]);export{u as __pageData,b as default};
