import{_ as e,c as a,o as t,a2 as n}from"./chunks/framework.BaHG-QLs.js";const u=JSON.parse('{"title":"Class: RemoteBase","description":"","frontmatter":{},"headers":[],"relativePath":"api/remote/classes/RemoteBase.md","filePath":"api/remote/classes/RemoteBase.md"}'),r={name:"api/remote/classes/RemoteBase.md"},s=n(`<h1 id="class-remotebase" tabindex="-1">Class: RemoteBase <a class="header-anchor" href="#class-remotebase" aria-label="Permalink to &quot;Class: RemoteBase&quot;">​</a></h1><p>The ancestor for WireClient, GoogleDrive &amp; Dropbox</p><h2 id="extends" tabindex="-1">Extends <a class="header-anchor" href="#extends" aria-label="Permalink to &quot;Extends&quot;">​</a></h2><ul><li><code>EventHandling</code></li></ul><h2 id="methods" tabindex="-1">Methods <a class="header-anchor" href="#methods" aria-label="Permalink to &quot;Methods&quot;">​</a></h2><h3 id="addeventlistener" tabindex="-1">addEventListener() <a class="header-anchor" href="#addeventlistener" aria-label="Permalink to &quot;addEventListener()&quot;">​</a></h3><blockquote><p><strong>addEventListener</strong>(<code>eventName</code>, <code>handler</code>): <code>void</code></p></blockquote><p>Install an event handler for the given event name</p><p>Usually called via <a href="#on"><code>on()</code></a></p><h4 id="parameters" tabindex="-1">Parameters <a class="header-anchor" href="#parameters" aria-label="Permalink to &quot;Parameters&quot;">​</a></h4><p>• <strong>eventName</strong>: <code>string</code></p><p>• <strong>handler</strong>: <a href="./../../eventhandling/type-aliases/EventHandler.html"><code>EventHandler</code></a></p><h4 id="returns" tabindex="-1">Returns <a class="header-anchor" href="#returns" aria-label="Permalink to &quot;Returns&quot;">​</a></h4><p><code>void</code></p><h4 id="inherited-from" tabindex="-1">Inherited from <a class="header-anchor" href="#inherited-from" aria-label="Permalink to &quot;Inherited from&quot;">​</a></h4><p><code>EventHandling.addEventListener</code></p><h4 id="defined-in" tabindex="-1">Defined in <a class="header-anchor" href="#defined-in" aria-label="Permalink to &quot;Defined in&quot;">​</a></h4><p><a href="https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/eventhandling.ts#L29" target="_blank" rel="noreferrer">eventhandling.ts:29</a></p><hr><h3 id="on" tabindex="-1">on() <a class="header-anchor" href="#on" aria-label="Permalink to &quot;on()&quot;">​</a></h3><blockquote><p><strong>on</strong>(<code>eventName</code>, <code>handler</code>): <code>void</code></p></blockquote><p>Register an event handler for the given event name</p><p>Alias for <a href="./RemoteBase.html#addeventlistener">addEventListener</a></p><h4 id="parameters-1" tabindex="-1">Parameters <a class="header-anchor" href="#parameters-1" aria-label="Permalink to &quot;Parameters&quot;">​</a></h4><p>• <strong>eventName</strong>: <code>string</code></p><p>Name of the event</p><p>• <strong>handler</strong>: <a href="./../../eventhandling/type-aliases/EventHandler.html"><code>EventHandler</code></a></p><p>Function to handle the event</p><h4 id="returns-1" tabindex="-1">Returns <a class="header-anchor" href="#returns-1" aria-label="Permalink to &quot;Returns&quot;">​</a></h4><p><code>void</code></p><h4 id="example" tabindex="-1">Example <a class="header-anchor" href="#example" aria-label="Permalink to &quot;Example&quot;">​</a></h4><div class="language-ts vp-adaptive-theme"><button title="Copy Code" class="copy"></button><span class="lang">ts</span><pre class="shiki shiki-themes github-light github-dark vp-code" tabindex="0"><code><span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">remoteStorage.</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">on</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&#39;connected&#39;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">, </span><span style="--shiki-light:#D73A49;--shiki-dark:#F97583;">function</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">() {</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">  console.</span><span style="--shiki-light:#6F42C1;--shiki-dark:#B392F0;">log</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">(</span><span style="--shiki-light:#032F62;--shiki-dark:#9ECBFF;">&#39;storage account has been connected&#39;</span><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">);</span></span>
<span class="line"><span style="--shiki-light:#24292E;--shiki-dark:#E1E4E8;">});</span></span></code></pre></div><h4 id="inherited-from-1" tabindex="-1">Inherited from <a class="header-anchor" href="#inherited-from-1" aria-label="Permalink to &quot;Inherited from&quot;">​</a></h4><p><code>EventHandling.on</code></p><h4 id="defined-in-1" tabindex="-1">Defined in <a class="header-anchor" href="#defined-in-1" aria-label="Permalink to &quot;Defined in&quot;">​</a></h4><p><a href="https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/eventhandling.ts#L55" target="_blank" rel="noreferrer">eventhandling.ts:55</a></p><hr><h3 id="removeeventlistener" tabindex="-1">removeEventListener() <a class="header-anchor" href="#removeeventlistener" aria-label="Permalink to &quot;removeEventListener()&quot;">​</a></h3><blockquote><p><strong>removeEventListener</strong>(<code>eventName</code>, <code>handler</code>): <code>void</code></p></blockquote><p>Remove a previously installed event handler</p><h4 id="parameters-2" tabindex="-1">Parameters <a class="header-anchor" href="#parameters-2" aria-label="Permalink to &quot;Parameters&quot;">​</a></h4><p>• <strong>eventName</strong>: <code>string</code></p><p>• <strong>handler</strong>: <a href="./../../eventhandling/type-aliases/EventHandler.html"><code>EventHandler</code></a></p><h4 id="returns-2" tabindex="-1">Returns <a class="header-anchor" href="#returns-2" aria-label="Permalink to &quot;Returns&quot;">​</a></h4><p><code>void</code></p><h4 id="inherited-from-2" tabindex="-1">Inherited from <a class="header-anchor" href="#inherited-from-2" aria-label="Permalink to &quot;Inherited from&quot;">​</a></h4><p><code>EventHandling.removeEventListener</code></p><h4 id="defined-in-2" tabindex="-1">Defined in <a class="header-anchor" href="#defined-in-2" aria-label="Permalink to &quot;Defined in&quot;">​</a></h4><p><a href="https://github.com/remotestorage/remotestorage.js/blob/a199c15fb409a17fd444aa7fba846e7fecc5981d/src/eventhandling.ts#L62" target="_blank" rel="noreferrer">eventhandling.ts:62</a></p>`,49),o=[s];function i(d,l,h,c,p,m){return t(),a("div",null,o)}const g=e(r,[["render",i]]);export{u as __pageData,g as default};
